/*
 * -------------------------------------------------------------------------
 * Implementation Dependent Data for FILE servers.
 * server->impdep will point to this.
 * -------------------------------------------------------------------------
 */

typedef struct _file_impdep_type {
  char *		spool_root;
  char *		lib_root;
  char *		overview_root;
  char *		inews_program;
  char *		dir_sep;
  buffer_type *		connect_data_mem; /* copy of connect data held here */
  buffer_type *		buffer;		/* buffer for holding .overview,
					 * article, active, etc...
					 */
} file_impdep_type;


#define FILE_STUFF(s1)	((file_impdep_type *)((s1)->impdep))

int
read_file_into_buffer (char * filename, buffer_type ** bufferp);

int
scan_group (char * dirname,
	    unsigned long * low,
	    unsigned long * high,
	    unsigned long * count,
	    unsigned long * artnums);

char *
construct_group_pathname (news_server_type * server,
				 char * group,
				 unsigned long artnum);

char *
construct_overview_pathname (news_server_type * server,
				    char * group);

int
generate_overview (FILE * fd,
		   unsigned long artnum,
		   news_overview_type * nov,
		   buffer_type * line_buf,
		   buffer_type * ov_buf);

